-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
/*** #4. Correlated SubQuery VS Derived table ***/

/*** Using Correlated SubQuery ***/
SELECT P.ProductID, (SELECT SUM(Linetotal) AS Sumtotal FROM Sales.SalesOrderDetail S WHERE S.ProductId=P.ProductId) AS SumTotal 
FROM Production.product P 
WHERE ProductNumber LIKE 'fr%' AND (SELECT SUM(Linetotal) AS Sumtotal FROM Sales.SalesOrderDetail S WHERE S.ProductId=P.ProductId) IS NOT NULL

/*** Using Derived table ***/
SELECT P.ProductID,S.Sumtotal AS SumTotal 
FROM Production.product P 
INNER JOIN ( SELECT ProductId,SUM(Linetotal) AS Sumtotal FROM Sales.SalesOrderDetail GROUP BY Sales.SalesOrderDetail.ProductID) S ON S.ProductID=P.ProductID 
WHERE P.ProductNumber LIKE 'fr%'

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
/*** Left Outer Join VS Correlated subquery ***/
IF OBJECT_ID('dbo.Parent') IS NOT NULL
BEGIN
		DROP TABLE dbo.Parent
END
GO

CREATE TABLE dbo.Parent
(
ParentId int not null,
name varchar(500) not null
)
GO

IF OBJECT_ID('dbo.Child') IS NOT NULL
BEGIN
		DROP TABLE dbo.Child
END
GO

CREATE TABLE dbo.Child
(
ChildId int IDENTITY(1,1)  not null,
ParentId int not null,
childname varchar(100) not null
)

INSERT INTO dbo.Parent
SELECT TOP (1000000) rn, 'Row: ' + CONVERT(VARCHAR,rn)
FROM (
SELECT ROW_NUMBER() OVER (ORDER BY (SELECT 1)) AS rn
FROM sys.columns C
CROSS JOIN sys.columns A 
CROSS JOIN sys.columns B 
) AS D
GO

CREATE CLUSTERED INDEX XPKParentId ON dbo.Parent 
(
ParentId ASC
)

SELECT P.ParentId,P.name,(SELECT C.Childname FROM Child C WHERE C.ChildId=P.ParentId) AS Childname
FROM dbo.Parent P 
WHERE P.ParentId<1000

SELECT P.ParentId,P.name,C.Childname
FROM dbo.Parent P 
LEFT OUTER JOIN dbo.Child C ON C.ChildId=P.ParentId
WHERE P.ParentId<1000

SELECT P.ParentId,P.name
FROM dbo.Parent P
WHERE EXISTS(SELECT C.Childname FROM dbo.Child C WHERE C.ChildId=P.ParentId)