CREATE TABLE T1 (c_int int, C_Real Real)
CREATE CLUSTERED INDEX T1_C_Real ON T1(C_Real)

CREATE TABLE T2 (c_int int, C_Real Real)
CREATE CLUSTERED INDEX T2_C_INT ON T2(c_int)

SET NOCOUNT ON
DECLARE @I INT
SET @I = 0
WHILE @I < 30000
  BEGIN
    INSERT T1 VALUES (@I, @I)
    INSERT T2 VALUES (@I, @I)
    SET @I = @I + 1
  END 

DECLARE @starttime datetime
SET @starttime=GETDATE()

SELECT COUNT(*)
FROM T1 INNER LOOP JOIN T2 ON T1.C_INT = T2.C_INT

PRINT 'Duration with queries: ' + CAST(DATEDIFF(ms, @StartTime, GETDATE()) AS varchar(10)) + ' ms'
GO

DECLARE @starttime datetime
SET @starttime=GETDATE()
SELECT COUNT(*)
FROM T1 INNER LOOP JOIN T2 ON T1.C_REAL = T2.C_INT

PRINT 'Duration with queries: ' + CAST(DATEDIFF(ms, @StartTime, GETDATE()) AS varchar(10)) + ' ms'
GO

DECLARE @tmp AS TABLE
(myvarchar varchar(50) PRIMARY KEY)

DECLARE @myparam AS varchar(50)

INSERT INTO @tmp VALUES ('test')
SET @myparam = 'test'

SELECT *
FROM @tmp
WHERE myvarchar = @myparam
