Run this in northwind database
/*** #1. Illustrating the incorrect results with NOT IN clause ***/

/* Updating customerID to NULL inorder to explain the incorrect results with NOT IN clause */
UPDATE dbo.Orders
SET CustomerID = null
WHERE OrderID=11077	

/* NOT IN gives incorrect results when there are NULL values */
SELECT companyname,CustomerID 
FROM customers 
WHERE customerid NOT IN (SELECT customerid FROM orders)

/* Checking for NULL values to get the correct results using NOT IN clause */
SELECT companyname,CustomerID
FROM customers 
WHERE customerid NOT IN (SELECT customerid FROM orders WHERE CustomerID IS NOT NULL)

--------------------------------------------------------------------------------------------------

/*** #2. Performance between NOT IN VS NOT EXISTS clause ***/

SELECT companyname,CustomerID 
FROM customers C
WHERE NOT EXISTS(SELECT customerid FROM orders O WHERE O.CustomerID =C.CustomerID)

SELECT companyname,CustomerID 
FROM customers 
WHERE customerid NOT IN (SELECT customerid FROM orders) 

/* Updating the NULL value back to original value */
UPDATE dbo.Orders
SET CustomerID='ALFKI'
WHERE OrderID=11077

---------------------------------------------------------------------------------------------------

/*** #3. Performance between NOT IN VS LEFT OUTER JOIN ***/

SELECT C.CompanyName,C.CustomerID
FROM Customers C LEFT OUTER JOIN Orders O ON C.CustomerID=O.CustomerID
WHERE O.CustomerID IS NULL 
