/*** Performance impact when using SET NOCOUNT OFF in stored procedures***/

CREATE TABLE TEST
(
TestId bigint IDENTITY(1,1),
Testdata varchar(max)
)
GO

CREATE PROCEDURE InsertTestwithnocountON
(
@Testdata varchar(max)
)
AS
BEGIN
SET NOCOUNT ON
	INSERT INTO TEST(Testdata)
	VALUES(@Testdata)
SET NOCOUNT OFF
END
GO

CREATE PROCEDURE InsertTestwithnocountOFF
(
@Testdata varchar(max)
)
AS
BEGIN
	INSERT INTO TEST(Testdata)
	VALUES(@Testdata)
END
GO

DECLARE @Starttime datetime=getdate(),
		@endtime datetime,
		@loop bigint=0,
		@maxcount bigint=10000
		
WHILE @loop<@maxcount
BEGIN
	EXEC InsertTestwithnocountON 'abcd'
	SET @loop=@loop+1	
END 

SET @endtime=GETDATE()

PRINT 'Duration using SET NOCOUNT ON: ' + CONVERT(varchar(100),DATEDIFF(ms,@starttime,@endtime))
GO

DECLARE @Starttime datetime=getdate(),
		@endtime datetime,
		@loop bigint=0,
		@maxcount bigint=10000
		
WHILE @loop<@maxcount
BEGIN
	EXEC InsertTestwithnocountON 'abcd'
	SET @loop=@loop+1	
END 

SET @endtime=GETDATE()

SELECT DATEDIFF(ms,@starttime,@endtime)	AS Duration

PRINT 'Duration using SET NOCOUNT ON: ' + CONVERT(varchar(100),DATEDIFF(ms,@starttime,@endtime))
GO

DROP TABLE Test
GO
DROP PROCEDURE InsertTestwithnocountON
GO
DROP PROCEDURE InsertTestwithnocountOFF
GO