/*** Performance of Catch-All queries ***/

/*** General way of using OR operator ***/
DECLARE 
		@ProductId bigint=776,
		@SpecialOfferID int=null
SELECT 
	SalesOrderID,
	SalesOrderDetailID,
	CarrierTrackingNumber,
	OrderQty,
	ProductID,
	SpecialOfferID,
	UnitPrice,
	UnitPriceDiscount,
	LineTotal,
	rowguid,
	ModifiedDate 
FROM Sales.SalesOrderDetail
WHERE (ProductId=@ProductId OR @ProductId IS NULL)
		AND (SpecialOfferID=@SpecialOfferID OR @SpecialOfferID IS NULL)
GO

/*** Optimal way using dynamic sql ***/
DECLARE 
		@ProductId bigint=776,
		@SpecialOfferID int=null
DECLARE @sql nvarchar(max)
SET @sql='
				SELECT 
						SalesOrderID,
						SalesOrderDetailID,
						CarrierTrackingNumber,
						OrderQty,
						ProductID,
						SpecialOfferID,
						UnitPrice,
						UnitPriceDiscount,
						LineTotal,
						rowguid,
						ModifiedDate 
				FROM Sales.SalesOrderDetail
				WHERE 1=1 ' + 
				CASE 
					WHEN @ProductId IS NULL
					THEN ''
					
					ELSE 'AND ProductId=@ProductId'	 
				END 	+ 
				
				CASE 
					WHEN @SpecialOfferID IS NULL
					THEN ''
					
					ELSE 'AND SpecialOfferId=@SpecialOfferId'
				END 	

EXECUTE sp_executesql 
							@sql,
							N'@ProductId bigint,@SpecialOfferId int',
							@ProductId =776,@SpecialOfferID=null				

GO
/*** Using CASE without dynamic sql ***/

DECLARE 
		@ProductId bigint=776,
		@SpecialOfferID int=null
SELECT 
		SalesOrderID,
		SalesOrderDetailID,
		CarrierTrackingNumber,
		OrderQty,
		ProductID,
		SpecialOfferID,
		UnitPrice,
		UnitPriceDiscount,
		LineTotal,
		rowguid,
		ModifiedDate 
FROM 
		Sales.SalesOrderDetail
WHERE (ProductID = CASE 
									WHEN @ProductId IS NULL 
										THEN ProductID
									ELSE @ProductId 
								END) 
AND (SpecialOfferID = CASE 
									WHEN @SpecialOfferID IS NULL
										THEN SpecialOfferID
									ELSE @SpecialOfferID
								 END)